fstests.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
* [PATCH] btrfs/022: Add qgroup assign test
@ 2020-09-20  8:57 Sidong Yang
  2020-09-20 17:27 ` Eryu Guan
  2020-09-21  1:21 ` Qu Wenruo
  0 siblings, 2 replies; 7+ messages in thread
From: Sidong Yang @ 2020-09-20  8:57 UTC (permalink / raw)
  To: linux-btrfs, fstests; +Cc: Sidong Yang, Qu Wenruo, Josef Bacik

The btrfs/022 test is basic test about qgroup. but it doesn't have
test with qgroup assign function. This patch adds parent assign
test. parent assign test make two subvolumes and a qgroup for assign.
Assign two subvolumes with a qgroup and check that quota of group
has same value with sum of two subvolumes.

Signed-off-by: Sidong Yang <realwakka@gmail.com>
---
 tests/btrfs/022 | 40 ++++++++++++++++++++++++++++++++++++++++
 1 file changed, 40 insertions(+)

diff --git a/tests/btrfs/022 b/tests/btrfs/022
index aaa27aaa..cafaa8b2 100755
--- a/tests/btrfs/022
+++ b/tests/btrfs/022
@@ -110,6 +110,40 @@ _limit_test_noexceed()
 	[ $? -eq 0 ] || _fail "should have been allowed to write"
 }
 
+#basic assign testing
+_parent_assign_test()
+{
+	echo "=== parent assign test ===" >> $seqres.full
+	_run_btrfs_util_prog subvolume create $SCRATCH_MNT/a
+	_run_btrfs_util_prog quota enable $SCRATCH_MNT
+	subvolid_a=$(_btrfs_get_subvolid $SCRATCH_MNT a)
+
+	_run_btrfs_util_prog subvolume create $SCRATCH_MNT/b
+	_run_btrfs_util_prog quota enable $SCRATCH_MNT
+	subvolid_b=$(_btrfs_get_subvolid $SCRATCH_MNT b)
+
+	_run_btrfs_util_prog qgroup create 1/100 $SCRATCH_MNT
+
+	_run_btrfs_util_prog qgroup assign 0/$subvolid_a 1/100 $SCRATCH_MNT
+	_run_btrfs_util_prog qgroup assign 0/$subvolid_b 1/100 $SCRATCH_MNT
+
+	_ddt of=$SCRATCH_MNT/a/file bs=4M count=1 >> $seqres.full 2>&1
+	_ddt of=$SCRATCH_MNT/b/file bs=4M count=1 >> $seqres.full 2>&1
+	sync
+
+	a_shared=$($BTRFS_UTIL_PROG qgroup show $units $SCRATCH_MNT | grep "0/$subvolid_a")
+	a_shared=$(echo $a_shared | awk '{ print $2 }' | tr -dc '0-9')
+
+	b_shared=$($BTRFS_UTIL_PROG qgroup show $units $SCRATCH_MNT | grep "0/$subvolid_b")
+	b_shared=$(echo $b_shared | awk '{ print $2 }' | tr -dc '0-9')
+	sum=$(expr $b_shared  + $a_shared)
+
+	q_shared=$($BTRFS_UTIL_PROG qgroup show $units $SCRATCH_MNT | grep "1/100")
+	q_shared=$(echo $q_shared | awk '{ print $2 }' | tr -dc '0-9')
+
+	[ $sum -eq $q_shared ] || _fail "shared values don't match"
+}
+
 units=`_btrfs_qgroup_units`
 
 _scratch_mkfs > /dev/null 2>&1
@@ -133,6 +167,12 @@ _check_scratch_fs
 _scratch_mkfs > /dev/null 2>&1
 _scratch_mount
 _limit_test_noexceed
+_scratch_unmount
+_check_scratch_fs
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+_parent_assign_test
 
 # success, all done
 echo "Silence is golden"
-- 
2.25.1


^ permalink raw reply related	[flat|nested] 7+ messages in thread

end of thread, other threads:[~2020-09-23  0:28 UTC | newest]

Thread overview: 7+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-09-20  8:57 [PATCH] btrfs/022: Add qgroup assign test Sidong Yang
2020-09-20 17:27 ` Eryu Guan
2020-09-21  0:55   ` Sidong Yang
2020-09-21  1:21 ` Qu Wenruo
2020-09-21 15:16   ` Sidong Yang
2020-09-21 23:49     ` Qu Wenruo
2020-09-23  0:28       ` Sidong Yang

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).